
import 'package:ez_localization/ez_localization.dart';
import 'package:in_app_review/in_app_review.dart';
import 'package:package_info_plus/package_info_plus.dart';
import 'package:share/share.dart';
import 'package:shared_preferences/shared_preferences.dart';

reviewApp({open: true, check: false}) async {
  var reviewed = false;

  if (check) {
    SharedPreferences prefs = await SharedPreferences.getInstance();
    reviewed = (prefs.getBool('reviewed') ?? false);

    if (!reviewed) {
      if (open) {
        await InAppReview.instance.openStoreListing();
      } else {
        var isAvailable = await InAppReview.instance.isAvailable();
        if (isAvailable) {
          await InAppReview.instance.requestReview();
          prefs.setBool('reviewed', true);
        } else {
          if (open) {
            await InAppReview.instance.openStoreListing();
          }
        }
      }
    }
  } else {
    if (open) {
      await InAppReview.instance.openStoreListing();
    } else {
      var isAvailable = await InAppReview.instance.isAvailable();
      if (isAvailable) {
        await InAppReview.instance.requestReview();
      } else {
        if (open) {
          await InAppReview.instance.openStoreListing();
        }
      }
    }
  }

  return reviewed;
}

shareApp(context , {subjectKey:"share_subject" , messageKey:"share_message"}) async {
  PackageInfo packageInfo = await PackageInfo.fromPlatform();

  String packageName = packageInfo.packageName;

  var subject = tran(context, subjectKey);
  String message = tran(context, messageKey) +
      "\n" +
      "https://play.google.com/store/apps/details?id=$packageName";
  Share.share(message, subject: subject);
}

/// translate text
String tran(context, key, {params}) {
  return EzLocalization.of(context).get(key, params);
}

/// notification
/*

initNotifications(context) async {
  String allTopics = "all";
  FirebaseMessaging.instance.subscribeToTopic(allTopics);

  // get message when app opened from terminated
  FirebaseMessaging.instance.getInitialMessage().then((value) {
    if (value != null) {
      //EasyLoading.showInfo(value.notification.title + " test");
    }
  });

  // get message on foreground and send notification
  FirebaseMessaging.onMessage.listen((RemoteMessage message) {
    print("new message : " + message.toString());
    showNotification(message.notification.title, message.notification.body);
  });

  // get message from app opened from background
  FirebaseMessaging.onMessageOpenedApp.listen((RemoteMessage message) {
    //EasyLoading.showInfo(message.notification.title);
    print("app opend : " + message.notification.title);
    print(message.data);
  });

  FirebaseMessaging.onBackgroundMessage(myBackgroundMessageHandler);
}

showNotification(title, body) async {
  const AndroidNotificationDetails androidPlatformChannelSpecifics =
  AndroidNotificationDetails('0', 'fcm', 'fcm notifications',
      importance: Importance.max,
      priority: Priority.high,
      showWhen: false);

  const NotificationDetails platformChannelSpecifics =
  NotificationDetails(android: androidPlatformChannelSpecifics);

  const AndroidInitializationSettings initializationSettingsAndroid =
  AndroidInitializationSettings("ic_launcher");
  final InitializationSettings initializationSettings =
  InitializationSettings(android: initializationSettingsAndroid);

  FlutterLocalNotificationsPlugin flutterLocalNotificationsPlugin;
  flutterLocalNotificationsPlugin = FlutterLocalNotificationsPlugin();
  await flutterLocalNotificationsPlugin.initialize(initializationSettings);

  await flutterLocalNotificationsPlugin
      .show(0, title, body, platformChannelSpecifics);
}


Future<void> myBackgroundMessageHandler(RemoteMessage message) async {
  print("background : " + message.notification.title);
}
 */